diff -ruN vdr-2.0.0/skins.h vdr-2.1.1/skins.h
--- vdr-2.0.0/skins.h	2012-12-21 12:09:13.000000000 +0100
+++ vdr-2.1.1/skins.h	2013-08-21 12:29:10.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skins.h 2.9 2012/12/21 11:09:13 kls Exp $
+ * $Id: skins.h 3.1 2013/08/21 10:29:10 kls Exp $
  */
 
 #ifndef __SKINS_H
@@ -14,6 +14,7 @@
 #include "epg.h"
 #include "keys.h"
 #include "osd.h"
+#include "positioner.h"
 #include "recording.h"
 #include "themes.h"
 #include "thread.h"
@@ -52,7 +53,10 @@
        ///< This class is used to display the current channel, together with
        ///< the present and following EPG event. How and to what extent this
        ///< is done is totally up to the derived class.
+private:
+  const cPositioner *positioner;
 public:
+  cSkinDisplayChannel(void);
   virtual void SetChannel(const cChannel *Channel, int Number) = 0;
        ///< Sets the current channel to Channel. If Number is not 0, the
        ///< user is in the process of entering a channel number, which must
@@ -65,6 +69,17 @@
        ///< to determine, e.g., the colors for displaying the Text.
        ///< If Text is NULL, any previously displayed message must be removed, and
        ///< any previous contents overwritten by the message must be restored.
+  virtual void SetPositioner(const cPositioner *Positioner);
+       ///< Sets the Positioner used to move the satellite dish. The skin may use the
+       ///< data provided by Positioner to implement some form of progress display,
+       ///< since moving the dish may take a while. This function will only be called
+       ///< if the device receiving the current live channel actually uses a positioner,
+       ///< and it will be called with NULL once the dish has reached its target
+       ///< position (or the user switches to a channel that doesn't require positioning
+       ///< the dish). While the dish is moving, SetPositioner() is called repeatedly,
+       ///< so the skin has a chance to update the progress display.
+       ///< The default implementation calls SetMessage() with a text that indicates
+       ///< that the dish is being moved to a new position.
   /*TODO
   SetButtons
     Red    = Video options
diff -ruN vdr-2.0.0/skinsttng.c vdr-2.1.1/skinsttng.c
--- vdr-2.0.0/skinsttng.c	2013-03-03 16:29:28.000000000 +0100
+++ vdr-2.1.1/skinsttng.c	2013-03-03 16:29:28.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.c 2.17 2013/03/03 15:29:28 kls Exp $
+ * $Id: skinsttng.c 3.0 2013/03/03 15:29:28 kls Exp $
  */
 
 // "Star Trek: The Next Generation"(R) is a registered trademark of Paramount Pictures
diff -ruN vdr-2.0.0/skinsttng.h vdr-2.1.1/skinsttng.h
--- vdr-2.0.0/skinsttng.h	2005-01-02 15:39:29.000000000 +0100
+++ vdr-2.1.1/skinsttng.h	2005-01-02 15:39:29.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinsttng.h 2.0 2005/01/02 14:39:29 kls Exp $
+ * $Id: skinsttng.h 3.0 2005/01/02 14:39:29 kls Exp $
  */
 
 #ifndef __SKINSTTNG_H
diff -ruN vdr-2.0.0/sourceparams.c vdr-2.1.1/sourceparams.c
--- vdr-2.0.0/sourceparams.c	2010-03-06 12:13:39.000000000 +0100
+++ vdr-2.1.1/sourceparams.c	2010-03-06 12:13:39.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sourceparams.c 1.2 2010/03/06 11:13:39 kls Exp $
+ * $Id: sourceparams.c 3.0 2010/03/06 11:13:39 kls Exp $
  */
 
 #include "sourceparams.h"
diff -ruN vdr-2.0.0/sourceparams.h vdr-2.1.1/sourceparams.h
--- vdr-2.0.0/sourceparams.h	2010-02-28 12:58:03.000000000 +0100
+++ vdr-2.1.1/sourceparams.h	2010-02-28 12:58:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sourceparams.h 1.1 2010/02/28 11:58:03 kls Exp $
+ * $Id: sourceparams.h 3.0 2010/02/28 11:58:03 kls Exp $
  */
 
 #ifndef __SOURCEPARAMS_H
diff -ruN vdr-2.0.0/sources.c vdr-2.1.1/sources.c
--- vdr-2.0.0/sources.c	2010-02-28 16:15:39.000000000 +0100
+++ vdr-2.1.1/sources.c	2013-05-23 12:20:28.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sources.c 2.2 2010/02/28 15:15:39 kls Exp $
+ * $Id: sources.c 3.4 2013/05/23 10:20:28 kls Exp $
  */
 
 #include "sources.h"
@@ -37,17 +37,29 @@
   return code != stNone && description && *description;
 }
 
+bool cSource::Matches(int Code1, int Code2)
+{
+  if (Code1 == (stSat | st_Any))
+     return IsSat(Code2);
+  return Code1 == Code2;
+}
+
+int cSource::Position(int Code)
+{
+  int n = (Code & st_Pos);
+  if (n > 0x00007FFF)
+     n |= 0xFFFF0000;
+  return n;
+}
+
 cString cSource::ToString(int Code)
 {
   char buffer[16];
   char *q = buffer;
   *q++ = (Code & st_Mask) >> 24;
-  int n = (Code & st_Pos);
-  if (n > 0x00007FFF)
-     n |= 0xFFFF0000;
-  if (n) {
+  if (int n = Position(Code)) {
      q += snprintf(q, sizeof(buffer) - 2, "%u.%u", abs(n) / 10, abs(n) % 10); // can't simply use "%g" here since the silly 'locale' messes up the decimal point
-     *q++ = (n < 0) ? 'E' : 'W';
+     *q++ = (n < 0) ? 'W' : 'E';
      }
   *q = 0;
   return buffer;
@@ -69,8 +81,8 @@
                                      break;
                    case '.':         dot = true;
                                      break;
-                   case 'E':         neg = true; // fall through to 'W'
-                   case 'W':         if (!dot)
+                   case 'W':         neg = true; // fall through to 'E'
+                   case 'E':         if (!dot)
                                         pos *= 10;
                                      break;
                    default: esyslog("ERROR: unknown source character '%c'", *s);
@@ -84,7 +96,7 @@
         return code;
         }
      else
-       esyslog("ERROR: unknown source key '%c'", *s);
+        esyslog("ERROR: unknown source key '%c'", *s);
      }
   return stNone;
 }
@@ -93,9 +105,9 @@
 {
   int code = SourceType;
   if (SourceType == stSat) {
-     if (East)
+     if (!East)
         Position = -Position;
-     code |= (Position & st_Pos);;
+     code |= (Position & st_Pos);
      }
   return code;
 }
diff -ruN vdr-2.0.0/sources.conf vdr-2.1.1/sources.conf
--- vdr-2.0.0/sources.conf	2013-03-11 12:24:07.000000000 +0100
+++ vdr-2.1.1/sources.conf	2013-05-23 12:10:23.000000000 +0200
@@ -179,6 +179,8 @@
 S137W   AMC 7
 S139W   AMC 8
 
+S360E   Any satellite
+
 # Cable
 
 C       DVB-C
diff -ruN vdr-2.0.0/sources.h vdr-2.1.1/sources.h
--- vdr-2.0.0/sources.h	2012-06-17 13:19:23.000000000 +0200
+++ vdr-2.1.1/sources.h	2013-08-21 12:27:32.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: sources.h 2.4 2012/06/17 11:19:23 kls Exp $
+ * $Id: sources.h 3.2 2013/08/21 10:27:32 kls Exp $
  */
 
 #ifndef __SOURCES_H
@@ -22,6 +22,7 @@
     stTerr  = ('T' << 24),
     st_Mask = 0xFF000000,
     st_Pos  = 0x0000FFFF,
+    st_Any  = 0x00000E10, // 3600 - special value indicating "any position"
     };
 private:
   int code;
@@ -31,8 +32,22 @@
   cSource(char Source, const char *Description);
   ~cSource();
   int Code(void) const { return code; }
+  int Position(void) { return Position(code); }
+      ///< Returns the orbital position of the satellite in case this is a DVB-S
+      ///< source (zero otherwise). The returned value is in the range -1800...+1800,
+      ///< except for the special value 3600, which indicates "any position". This is
+      ///< used with positioners that can move the dish to any requested satellite
+      ///< within their range.
+      ///< A positive sign indicates a position east of Greenwich, while western
+      ///< positions have a negative sign. The absolute value is in "degrees * 10",
+      ///< which allows for a resolution of 1/10 of a degree.
   const char *Description(void) const { return description; }
   bool Parse(const char *s);
+  static bool Matches(int Code1, int Code2);
+      ///< Returns true if Code2 matches Code1. This is simply a check whether the
+      ///< two codes are equal, except for the special case that Code1 is stSat|st_Any,
+      ///< in which case it matches any Code2 that is stSat.
+  static int Position(int Code);
   static char ToChar(int Code) { return (Code & st_Mask) >> 24; }
   static cString ToString(int Code);
   static int FromString(const char *s);
diff -ruN vdr-2.0.0/spu.c vdr-2.1.1/spu.c
--- vdr-2.0.0/spu.c	2008-02-10 15:06:48.000000000 +0100
+++ vdr-2.1.1/spu.c	2008-02-10 15:06:48.000000000 +0100
@@ -6,7 +6,7 @@
  * This code is distributed under the terms and conditions of the
  * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
  *
- * $Id: spu.c 2.0 2008/02/10 14:06:48 kls Exp $
+ * $Id: spu.c 3.0 2008/02/10 14:06:48 kls Exp $
  */
 
 #include "spu.h"
diff -ruN vdr-2.0.0/spu.h vdr-2.1.1/spu.h
--- vdr-2.0.0/spu.h	2006-04-17 14:48:55.000000000 +0200
+++ vdr-2.1.1/spu.h	2006-04-17 14:48:55.000000000 +0200
@@ -6,7 +6,7 @@
  * This code is distributed under the terms and conditions of the
  * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
  *
- * $Id: spu.h 2.0 2006/04/17 12:48:55 kls Exp $
+ * $Id: spu.h 3.0 2006/04/17 12:48:55 kls Exp $
  */
 
 #ifndef __SPU_VDR_H
diff -ruN vdr-2.0.0/status.c vdr-2.1.1/status.c
--- vdr-2.0.0/status.c	2012-03-07 15:17:24.000000000 +0100
+++ vdr-2.1.1/status.c	2012-03-07 15:17:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.c 2.1 2012/03/07 14:17:24 kls Exp $
+ * $Id: status.c 3.0 2012/03/07 14:17:24 kls Exp $
  */
 
 #include "status.h"
diff -ruN vdr-2.0.0/status.h vdr-2.1.1/status.h
--- vdr-2.0.0/status.h	2012-03-07 15:16:57.000000000 +0100
+++ vdr-2.1.1/status.h	2012-03-07 15:16:57.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: status.h 2.1 2012/03/07 14:16:57 kls Exp $
+ * $Id: status.h 3.0 2012/03/07 14:16:57 kls Exp $
  */
 
 #ifndef __STATUS_H
diff -ruN vdr-2.0.0/summary2info vdr-2.1.1/summary2info
--- vdr-2.0.0/summary2info	2011-12-04 15:17:35.000000000 +0100
+++ vdr-2.1.1/summary2info	2011-12-04 15:17:35.000000000 +0100
@@ -10,7 +10,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: summary2info 2.1 2011/12/04 14:17:35 kls Exp $
+# $Id: summary2info 3.0 2011/12/04 14:17:35 kls Exp $
 
 $VideoDir = $ARGV[0] || die "please provide the name of the video directory\n";
 
diff -ruN vdr-2.0.0/svdrp.c vdr-2.1.1/svdrp.c
--- vdr-2.0.0/svdrp.c	2013-02-17 14:18:01.000000000 +0100
+++ vdr-2.1.1/svdrp.c	2013-02-17 14:18:01.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.24 2013/02/17 13:18:01 kls Exp $
+ * $Id: svdrp.c 3.0 2013/02/17 13:18:01 kls Exp $
  */
 
 #include "svdrp.h"
diff -ruN vdr-2.0.0/svdrp.h vdr-2.1.1/svdrp.h
--- vdr-2.0.0/svdrp.h	2012-04-26 12:30:06.000000000 +0200
+++ vdr-2.1.1/svdrp.h	2012-04-26 12:30:06.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: svdrp.h 2.3 2012/04/26 10:30:06 kls Exp $
+ * $Id: svdrp.h 3.0 2012/04/26 10:30:06 kls Exp $
  */
 
 #ifndef __SVDRP_H
diff -ruN vdr-2.0.0/themes.c vdr-2.1.1/themes.c
--- vdr-2.0.0/themes.c	2012-02-17 14:57:32.000000000 +0100
+++ vdr-2.1.1/themes.c	2012-02-17 14:57:32.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: themes.c 2.2 2012/02/17 13:57:32 kls Exp $
+ * $Id: themes.c 3.0 2012/02/17 13:57:32 kls Exp $
  */
 
 #include "themes.h"
diff -ruN vdr-2.0.0/themes.h vdr-2.1.1/themes.h
--- vdr-2.0.0/themes.h	2012-10-07 13:11:43.000000000 +0200
+++ vdr-2.1.1/themes.h	2012-10-07 13:11:43.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: themes.h 2.1 2012/10/07 11:11:43 kls Exp $
+ * $Id: themes.h 3.0 2012/10/07 11:11:43 kls Exp $
  */
 
 #ifndef __THEMES_H
diff -ruN vdr-2.0.0/thread.c vdr-2.1.1/thread.c
--- vdr-2.0.0/thread.c	2013-02-22 15:52:49.000000000 +0100
+++ vdr-2.1.1/thread.c	2013-04-10 16:37:37.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 2.7 2013/02/22 14:52:49 kls Exp $
+ * $Id: thread.c 3.1 2013/04/10 14:37:37 kls Exp $
  */
 
 #include "thread.h"
@@ -229,7 +229,7 @@
 
 void cThread::SetIOPriority(int Priority)
 {
-  if (syscall(SYS_ioprio_set, 1, 0, (Priority & 0xff) | (2 << 13)) < 0) // best effort class
+  if (syscall(SYS_ioprio_set, 1, 0, (Priority & 0xff) | (3 << 13)) < 0) // idle class
      LOG_ERROR;
 }
 
diff -ruN vdr-2.0.0/thread.h vdr-2.1.1/thread.h
--- vdr-2.0.0/thread.h	2013-02-16 16:20:44.000000000 +0100
+++ vdr-2.1.1/thread.h	2013-04-11 10:47:31.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.h 2.4 2013/02/16 15:20:44 kls Exp $
+ * $Id: thread.h 3.1 2013/04/11 08:47:31 kls Exp $
  */
 
 #ifndef __THREAD_H
@@ -182,7 +182,6 @@
        ///< Returns true if any I/O throttling object is currently active.
   };
 
-
 // cPipe implements a pipe that closes all unnecessary file descriptors in
 // the child process.
 
diff -ruN vdr-2.0.0/timers.c vdr-2.1.1/timers.c
--- vdr-2.0.0/timers.c	2013-03-29 16:37:16.000000000 +0100
+++ vdr-2.1.1/timers.c	2013-03-29 16:37:16.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 2.18 2013/03/29 15:37:16 kls Exp $
+ * $Id: timers.c 3.0 2013/03/29 15:37:16 kls Exp $
  */
 
 #include "timers.h"
diff -ruN vdr-2.0.0/timers.h vdr-2.1.1/timers.h
--- vdr-2.0.0/timers.h	2013-03-11 11:35:53.000000000 +0100
+++ vdr-2.1.1/timers.h	2013-03-11 11:35:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.h 2.7 2013/03/11 10:35:53 kls Exp $
+ * $Id: timers.h 3.0 2013/03/11 10:35:53 kls Exp $
  */
 
 #ifndef __TIMERS_H
diff -ruN vdr-2.0.0/tools.c vdr-2.1.1/tools.c
--- vdr-2.0.0/tools.c	2012-12-08 12:16:30.000000000 +0100
+++ vdr-2.1.1/tools.c	2013-05-07 10:48:00.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 2.29 2012/12/08 11:16:30 kls Exp $
+ * $Id: tools.c 3.1 2013/05/07 08:48:00 kls Exp $
  */
 
 #include "tools.h"
@@ -691,12 +691,12 @@
   begin = Now() + Ms;
 }
 
-bool cTimeMs::TimedOut(void)
+bool cTimeMs::TimedOut(void) const
 {
   return Now() >= begin;
 }
 
-uint64_t cTimeMs::Elapsed(void)
+uint64_t cTimeMs::Elapsed(void) const
 {
   return Now() - begin;
 }
diff -ruN vdr-2.0.0/tools.h vdr-2.1.1/tools.h
--- vdr-2.0.0/tools.h	2013-02-17 14:18:06.000000000 +0100
+++ vdr-2.1.1/tools.h	2013-08-23 12:32:51.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 2.24 2013/02/17 13:18:06 kls Exp $
+ * $Id: tools.h 3.2 2013/08/23 10:32:51 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -31,9 +31,9 @@
 
 extern int SysLogLevel;
 
-#define esyslog(a...) void( (SysLogLevel > 0) ? syslog_with_tid(LOG_ERR, a) : void() )
-#define isyslog(a...) void( (SysLogLevel > 1) ? syslog_with_tid(LOG_ERR, a) : void() )
-#define dsyslog(a...) void( (SysLogLevel > 2) ? syslog_with_tid(LOG_ERR, a) : void() )
+#define esyslog(a...) void( (SysLogLevel > 0) ? syslog_with_tid(LOG_ERR,   a) : void() )
+#define isyslog(a...) void( (SysLogLevel > 1) ? syslog_with_tid(LOG_INFO,  a) : void() )
+#define dsyslog(a...) void( (SysLogLevel > 2) ? syslog_with_tid(LOG_DEBUG, a) : void() )
 
 #define LOG_ERROR         esyslog("ERROR (%s,%d): %m", __FILE__, __LINE__)
 #define LOG_ERROR_STR(s)  esyslog("ERROR (%s,%d): %s: %m", __FILE__, __LINE__, s)
@@ -64,6 +64,8 @@
 #define BCDCHARTOINT(x) (10 * ((x & 0xF0) >> 4) + (x & 0xF))
 int BCD2INT(int x);
 
+#define IsBitSet(v, b) ((v) & (1 << (b))) // checks if the bit at index b is set in v, where the least significant bit has index 0
+
 // Unfortunately there are no platform independent macros for unaligned
 // access, so we do it this way:
 
@@ -330,8 +332,8 @@
       ///< time.
   static uint64_t Now(void);
   void Set(int Ms = 0);
-  bool TimedOut(void);
-  uint64_t Elapsed(void);
+  bool TimedOut(void) const;
+  uint64_t Elapsed(void) const;
   };
 
 class cReadLine {
diff -ruN vdr-2.0.0/transfer.c vdr-2.1.1/transfer.c
--- vdr-2.0.0/transfer.c	2013-03-01 10:50:15.000000000 +0100
+++ vdr-2.1.1/transfer.c	2013-08-22 14:33:02.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 2.8 2013/03/01 09:50:15 kls Exp $
+ * $Id: transfer.c 3.1 2013/08/22 12:33:02 kls Exp $
  */
 
 #include "transfer.h"
@@ -35,7 +35,7 @@
      cPlayer::Detach();
 }
 
-#define MAXRETRIES     5 // max. number of retries for a single TS packet
+#define MAXRETRIES    20 // max. number of retries for a single TS packet
 #define RETRYWAIT      5 // time (in ms) between two retries
 
 void cTransfer::Receive(uchar *Data, int Length)
diff -ruN vdr-2.0.0/transfer.h vdr-2.1.1/transfer.h
--- vdr-2.0.0/transfer.h	2013-03-01 10:49:46.000000000 +0100
+++ vdr-2.1.1/transfer.h	2013-03-01 10:49:46.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.h 2.4 2013/03/01 09:49:46 kls Exp $
+ * $Id: transfer.h 3.0 2013/03/01 09:49:46 kls Exp $
  */
 
 #ifndef __TRANSFER_H
diff -ruN vdr-2.0.0/vdr.c vdr-2.1.1/vdr.c
--- vdr-2.0.0/vdr.c	2013-03-15 11:44:54.000000000 +0100
+++ vdr-2.1.1/vdr.c	2013-06-10 16:28:43.000000000 +0200
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.57 2013/03/15 10:44:54 kls Exp $
+ * $Id: vdr.c 3.1 2013/06/10 14:28:43 kls Exp $
  */
 
 #include <getopt.h>
@@ -800,6 +800,11 @@
   if (AudioCommand)
      new cExternalAudio(AudioCommand);
 
+  // Positioner:
+
+  if (!cPositioner::GetPositioner()) // no plugin has created a positioner
+     new cDiseqcPositioner;
+
   // Channel:
 
   if (!cDevice::WaitForAllDevicesReady(DEVICEREADYTIMEOUT))
@@ -1400,6 +1405,7 @@
      Setup.Save();
      }
   cDevice::Shutdown();
+  cPositioner::DestroyPositioner();
   EpgHandlers.Clear();
   PluginManager.Shutdown(true);
   cSchedules::Cleanup(true);
diff -ruN vdr-2.0.0/videodir.c vdr-2.1.1/videodir.c
--- vdr-2.0.0/videodir.c	2012-09-30 14:06:33.000000000 +0200
+++ vdr-2.1.1/videodir.c	2013-08-23 14:28:06.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: videodir.c 2.4 2012/09/30 12:06:33 kls Exp $
+ * $Id: videodir.c 3.1 2013/08/23 12:28:06 kls Exp $
  */
 
 #include "videodir.h"
@@ -19,6 +19,8 @@
 #include "recording.h"
 #include "tools.h"
 
+//#define DEPRECATED_DISTRIBUTED_VIDEODIR // Code enclosed with this macro is deprecated and will be removed in a future version
+
 const char *VideoDirectory = VIDEODIR;
 
 void SetVideoDirectory(const char *Directory)
@@ -27,43 +29,60 @@
 }
 
 class cVideoDirectory {
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
 private:
   char *name, *stored, *adjusted;
   int length, number, digits;
+#endif
 public:
   cVideoDirectory(void);
   ~cVideoDirectory();
   int FreeMB(int *UsedMB = NULL);
-  const char *Name(void) { return name ? name : VideoDirectory; }
+  const char *Name(void) { return
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
+                                  name ? name :
+#endif
+                                                VideoDirectory; }
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   const char *Stored(void) { return stored; }
   int Length(void) { return length; }
   bool IsDistributed(void) { return name != NULL; }
   bool Next(void);
   void Store(void);
   const char *Adjust(const char *FileName);
+#endif
   };
 
 cVideoDirectory::cVideoDirectory(void)
 {
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   length = strlen(VideoDirectory);
   name = (VideoDirectory[length - 1] == '0') ? strdup(VideoDirectory) : NULL;
   stored = adjusted = NULL;
   number = -1;
   digits = 0;
+#endif
 }
 
 cVideoDirectory::~cVideoDirectory()
 {
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   free(name);
   free(stored);
   free(adjusted);
+#endif
 }
 
 int cVideoDirectory::FreeMB(int *UsedMB)
 {
-  return FreeDiskSpaceMB(name ? name : VideoDirectory, UsedMB);
+  return FreeDiskSpaceMB(
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
+                         name ? name :
+#endif
+                                       VideoDirectory, UsedMB);
 }
 
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
 bool cVideoDirectory::Next(void)
 {
   if (name) {
@@ -107,6 +126,7 @@
      }
   return NULL;
 }
+#endif
 
 cUnbufferedFile *OpenVideoFile(const char *FileName, int Flags)
 {
@@ -118,6 +138,7 @@
      errno = ENOENT; // must set 'errno' - any ideas for a better value?
      return NULL;
      }
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   // Are we going to create a new file?
   if ((Flags & O_CREAT) != 0) {
      cVideoDirectory Dir;
@@ -143,6 +164,7 @@
            }
         }
      }
+#endif
   cUnbufferedFile *File = cUnbufferedFile::Create(ActualFileName, Flags, DEFFILEMODE);
   if (ActualFileName != FileName)
      free((char *)ActualFileName);
@@ -176,6 +198,7 @@
 bool VideoFileSpaceAvailable(int SizeMB)
 {
   cVideoDirectory Dir;
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   if (Dir.IsDistributed()) {
      if (Dir.FreeMB() >= SizeMB * 2) // base directory needs additional space
         return true;
@@ -185,6 +208,7 @@
            }
      return false;
      }
+#endif
   return Dir.FreeMB() >= SizeMB;
 }
 
@@ -193,11 +217,15 @@
   int free = 0, used = 0;
   int deleted = DeletedRecordings.TotalFileSizeMB();
   cVideoDirectory Dir;
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   do {
+#endif
      int u;
      free += Dir.FreeMB(&u);
      used += u;
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
      } while (Dir.Next());
+#endif
   if (deleted > used)
      deleted = used; // let's not get beyond 100%
   free += deleted;
@@ -232,18 +260,26 @@
 void RemoveEmptyVideoDirectories(const char *IgnoreFiles[])
 {
   cVideoDirectory Dir;
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   do {
+#endif
      RemoveEmptyDirectories(Dir.Name(), false, IgnoreFiles);
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
      } while (Dir.Next());
+#endif
 }
 
 bool IsOnVideoDirectoryFileSystem(const char *FileName)
 {
   cVideoDirectory Dir;
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
   do {
+#endif
      if (EntriesOnSameFileSystem(Dir.Name(), FileName))
         return true;
+#ifdef DEPRECATED_DISTRIBUTED_VIDEODIR
      } while (Dir.Next());
+#endif
   return false;
 }
 
diff -ruN vdr-2.0.0/videodir.h vdr-2.1.1/videodir.h
--- vdr-2.0.0/videodir.h	2012-09-30 13:01:15.000000000 +0200
+++ vdr-2.1.1/videodir.h	2012-09-30 13:01:15.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: videodir.h 2.3 2012/09/30 11:01:15 kls Exp $
+ * $Id: videodir.h 3.0 2012/09/30 11:01:15 kls Exp $
  */
 
 #ifndef __VIDEODIR_H
